###################################################
### chunk number 1: 
###################################################
#line 411 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"


###################################################
### chunk number 2: 
###################################################
#line 412 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
set.seed(0)
require(BACCO)
data(toy)


###################################################
### chunk number 3: 
###################################################
#line 418 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
toy <- latin.hypercube(20,6)
head(toy)


###################################################
### chunk number 4: 
###################################################
#line 429 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
f <- function(x) sum( (0:6)*x)
expectation <- apply(regressor.multi(toy), 1, f)


###################################################
### chunk number 5: 
###################################################
#line 439 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
toy.scales <- rep(1,6)
toy.sigma <- 0.4
A <- toy.sigma*corr.matrix(xold=toy,scales=toy.scales)


###################################################
### chunk number 6: 
###################################################
#line 451 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"


###################################################
### chunk number 7: 
###################################################
#line 452 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
require(mvtnorm)


###################################################
### chunk number 8: 
###################################################
#line 457 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
d <-  as.vector(rmvnorm(n=1 , mean=expectation , sigma=A))


###################################################
### chunk number 9: 
###################################################
#line 466 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
x.unknown <- rep(0.5 , 6)
jj <- interpolant(x.unknown, d, toy, scales=toy.scales, g=TRUE)
print(drop(jj$mstar.star))


###################################################
### chunk number 10: 
###################################################
#line 477 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
print(jj$betahat)


###################################################
### chunk number 11: 
###################################################
#line 482 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
print(jj$beta.marginal.sd)


###################################################
### chunk number 12: 
###################################################
#line 509 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
scales.optim <- optimal.scales(val=toy, scales.start=rep(1,6), d=d, give=FALSE)
print(scales.optim)


###################################################
### chunk number 13: 
###################################################
#line 524 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
interpolant(x.unknown, d, toy, scales=toy.scales  , g=FALSE)
interpolant(x.unknown, d, toy, scales=scales.optim, g=FALSE)


###################################################
### chunk number 14: 
###################################################
#line 573 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"

data(results.table) 
data(expert.estimates)
            # Decide which column we are interested in:
     output.col <- 26
     wanted.cols <- c(2:9,12:19)
            # Decide how many to keep;
            # 30-40 is about the most we can handle:
     wanted.row <- 1:27

            # Values to use are the ones that appear in goin.test2.comments:
     val <- results.table[wanted.row , wanted.cols]

            # Now normalize val so that 0<results.table[,i]<1 for all i:

     normalize <- function(x){(x-mins)/(maxes-mins)}
     unnormalize <- function(x){mins + (maxes-mins)*x}

     mins  <- expert.estimates$low 
     maxes <- expert.estimates$high
     jj <- t(apply(val,1,normalize))

     jj <- as.data.frame(jj) 
     names(jj) <- names(val)
     val <- jj

            ## Answer is the 19th (or 20th or ... or 26th)
     d  <- results.table[wanted.row ,  output.col]

scales.optim <- 
  c(0.054095, 0.007055, 0.034944, 10.772536, 0.085691, 0.144568, 0.033540, 
    0.641465, 0.235039, 0.046189, 0.949328, 0.055576, 0.058894, 0.098077,
    0.045411, 0.167629)

     A <- corr.matrix(val,scales=rep(1,ncol(val)), power=1.5)
     Ainv <-  solve(A)

            ## Now try to find the best correlation lengths:
            ## the idea is to minimize the maximum absolute deviation
            ## from the known points.

d.observed <- results.table[, output.col]
A <- corr.matrix(val,scales=scales.optim, power=2)
Ainv <- solve(A)

design.normalized <- as.matrix(t(apply(results.table[,wanted.cols],1,normalize)))
jj.preds <- interpolant.quick(design.normalized, d, val, Ainv, give.Z=TRUE,
                                 scales=scales.optim, power=2)
d.predicted <- jj.preds$mstar.star
d.errors <- jj.preds$Z

jj <- range(c(d.observed,d.predicted))
par(pty="s")
plot(d.observed, d.predicted, pch=16, asp=1,
     xlim=jj,ylim=jj,
     xlab=expression(paste(temperature," (",{}^o,C,"), model"   )),
     ylab=expression(paste(temperature," (",{}^o,C,"), emulator"))
     )

errorbar <- function(x,y,delta,serifwidth=7,...){
  if(abs(delta)<1e-5){return()}
  lines(x=c(x,x),y=c(y-delta,y+delta), ...)
  lines(x=c(x-serifwidth/2,x+serifwidth/2),
        y=c(y+delta,y+delta), ...
        )
  lines(x=c(x-serifwidth/2,x+serifwidth/2),
        y=c(y-delta,y-delta), ...
        )
}
  
for(i in 1:length(d.observed)){
  errorbar(x=d.observed[i],y=d.predicted[i],delta=qt(0.975,df=11)*d.errors[i],serifwidth=0.1,col="red")
}

abline(0,1)



###################################################
### chunk number 15: 
###################################################
#line 908 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
args(ht.fun)


###################################################
### chunk number 16: 
###################################################
#line 1259 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
load.the.files <- TRUE
#library(goldstein)
if(load.the.files){
  load("e10000")
  load("temps.jj")
  o <- order(temps.jj)
   
  load("probs.from.prior")
  j0 <- j0-min(j0)
}
x.pp <- cumsum(exp(j0[o] ))
plot(temps.jj[o],x.pp/max(x.pp),ylab="cumulative probability",xlab="temperature (C)",
     type="l",lty=1,main="Prior and posterior CDF for temperature in Northern Europe")
points(sort(temps.jj),(1:9000)/9000,type="l",lty=2)
legend(0,0.95,legend=c("posterior","prior"),lty=1:2)


###################################################
### chunk number 17: SetTheBib
###################################################
#line 1322 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
bib <- system.file( "doc", "uncertainty.bib", package = "emulator" )
bib <- sub('.bib$','',bib)


###################################################
### chunk number 18: usethebib
###################################################
#line 1327 "d:/Rcompile/CRANpkg/local/2.12/BACCO/inst/doc/both_papers.Rnw"
cat( "\\bibliography{",bib,"}\n",sep='')


